#include <vector>

#include "utility.h"

namespace akt {
    
    // Does simplified RLE where only runs of zeros get compressed
    template <typename T>
    std::vector<Run<T>> toZeroRle(const std::vector<T>& x);

    // Computes the AWarp distance (assumes that Runs of all values different than 0 have length 1)
    // If upperBound is true, returns the upper bound on the true DTW distance; otherwise returns a lower bound
    template <typename T>
    T awarp(const std::vector<Run<T>>& x, const std::vector<Run<T>>& y, bool upperBound);
    
} // end namespace akt