#include <algorithm>
#include <cmath>
#include <utility>
#include <vector>

#include "utility.h"

namespace akt 
{
    // Returns all optimal l-clusterings for l in [1, k]
    // The i-th vector in the result containts i elements, each being the length of the corresponding cluster, along with its mean
    // Runs in O(kn^2) time, similar to 1-D k-means DP
    template <typename T>
    std::vector<std::vector<std::pair<int, double>>> compress(const std::vector<T>& x, int k);

	// Compress x into k runs (or min(k, x.size()), to be precise) using the algorithm implemented in compress()
	template <typename T>
	std::vector<Run<double>> compressToRuns(const std::vector<T>& x, int k);

} // end namespace akt
